// plugin.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <string>

#include "plugin.h"
#include "ktextfile.h"

#define INTERP_EXE "c:\\perl\\bin\\perl.exe"
#define INTERP_DIR "c:\\perl\\bin\\"

std::string szScript;
HANDLE hDLL = 0;

BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved){
	hDLL = hModule;
	return TRUE;
}

//------------------------
//Exported Functions
//------------------------
extern "C"  char* __stdcall Plugin_GetURL(char* szMainUrl, char* szPage, DWORD Len, DWORD* pURLContentType){
	static KTEXTFILE* pTextFile = NULL;
	static int Parsed = 0;
	if( !Parsed ){
		if( pTextFile ){
			delete pTextFile;//Free previous object
		}
		pTextFile = new KTEXTFILE; //New object

		STARTUPINFO si = { 0 };
		PROCESS_INFORMATION pi = { 0 };
		si.cb = sizeof( STARTUPINFO );

		std::string szCmdLine = INTERP_EXE;
		szCmdLine += " ";
		szCmdLine += szScript;
//		szCmdLine += " c:\\in.txt  c:\\out.txt";

		//create input file
		FILE* f = fopen( "c:\\in.txt", "w" );
		fwrite(szPage, Len, 1, f);
		fclose(f);

		char* strbuf = ( char* )malloc( strlen( szCmdLine.c_str() ) + 1 );
		strcpy(strbuf, szCmdLine.c_str());
		if( !CreateProcess( 0, strbuf, 0, 0, 0, 0, 0, INTERP_DIR, &si, &pi ) ){
			free( strbuf );
			char bbb[1024];
			sprintf(bbb, "ERROR %s => %d", szCmdLine, GetLastError());
			MessageBox( 0, bbb, 0, MB_ICONERROR|MB_TOPMOST );
			return 0;
		}
		WaitForSingleObject( pi.hThread, INFINITE );
		free( strbuf );
		CloseHandle( pi.hThread );
		CloseHandle( pi.hProcess );

		if(pTextFile->Init( "c:\\out.txt" )==0){//Out file not found. Skip
			delete pTextFile;
			pTextFile = 0;
			return 0;
		}
		Parsed = 1;
	}

	char* s = pTextFile->ReadLineA();//Read next url from file
	if( !s ){
		Parsed = 0;
	}
	*pURLContentType = OBJ_TYPE_RES;
	return s;
}

extern "C" void __stdcall Plugin_FreeURL(char* szFindedUrl){
	if(szFindedUrl)
		free(szFindedUrl);
}

//Return plugin name
extern "C" char* __stdcall Plugin_Init(DWORD v){
	char buffer[MAX_PATH];

	if(v != PLUGIN_SDK_VER)
		return 0;//Plugin SDK version mismatch

	GetModuleFileName((HMODULE)hDLL, buffer, MAX_PATH);
	for(DWORD i=(DWORD)strlen(buffer); i>0; i--){if(buffer[i-1]=='\\'){buffer[i]=0; break;}}
	strcat(buffer, "parser.pl");
	szScript = buffer;
	return "PERL scripting WebPump plugin";
}
